diff --git a/lib/Spawn/Safe.pm b/lib/Spawn/Safe.pm
index db47e3a..0b46f87 100644
--- a/lib/Spawn/Safe.pm
+++ b/lib/Spawn/Safe.pm
@@ -195,6 +195,17 @@ sub spawn_safe {
         my ( $dummy_stdin_read, $dummy_stdin_write );
         pipe( $dummy_stdin_read, $dummy_stdin_write ) || goto CHILD_ERR;
 
+	# be defensive, filehandles maybe tied() and (re)opening
+	# fails as seen under FCGI, sigh
+
+	local *STDIN;
+	local *STDOUT;
+	local *STDERR;
+
+	open( STDIN,  '<&=0' );
+	open( STDOUT, '>>&=1' );
+	open( STDERR, '>>&=2' );
+
         # Be 5.6 compatible and do it the old way.
         open( STDIN,  '<&' . fileno( $dummy_stdin_read   ) ) || goto CHILD_ERR;
         open( STDOUT, '>&' . fileno( $child_write_stdout ) ) || goto CHILD_ERR;
